Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 872)
+++ src/mlx/gui/flight.py	(revision 1008)
@@ -57,5 +57,5 @@
 #-----------------------------------------------------------------------------
 
-comboModel = gtk.ListStore(gobject.TYPE_STRING)
+comboModel = Gtk.ListStore(GObject.TYPE_STRING)
 comboModel.append(("N/A",))
 comboModel.append(("VECTORS",))
@@ -63,5 +63,5 @@
 #-----------------------------------------------------------------------------
 
-class Page(gtk.Alignment):
+class Page(Gtk.Alignment):
     """A page in the flight wizard."""
     def __init__(self, wizard, id, title, help, completedHelp = None):
@@ -72,17 +72,17 @@
                          padding_left = 12, padding_right = 12)
 
-        frame = gtk.Frame()
+        frame = Gtk.Frame()
         self.add(frame)
 
-        self._vbox = gtk.VBox()
+        self._vbox = Gtk.VBox()
         self._vbox.set_homogeneous(False)
         frame.add(self._vbox)
 
-        eventBox = gtk.EventBox()
-
-        alignment = gtk.Alignment(xalign = 0.0, xscale = 0.0)
-
-        titleLabel = gtk.Label(title)
-        titleLabel.modify_font(pango.FontDescription("bold 24"))
+        eventBox = Gtk.EventBox()
+
+        alignment = Gtk.Alignment(xalign = 0.0, xscale = 0.0)
+
+        titleLabel = Gtk.Label(title)
+        titleLabel.modify_font(Pango.FontDescription("bold 24"))
         alignment.set_padding(padding_top = 4, padding_bottom = 4,
                               padding_left = 6, padding_right = 0)
@@ -96,7 +96,7 @@
         self._titleLabel = titleLabel
 
-        mainBox = gtk.VBox()
-
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        mainBox = Gtk.VBox()
+
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 1.0, yscale = 1.0)
         alignment.set_padding(padding_top = 16, padding_bottom = 16,
@@ -105,5 +105,5 @@
         self._vbox.pack_start(alignment, True, True, 0)
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.0,
                                   xscale = 0.0, yscale = 0.0)
         alignment.set_padding(padding_top = 0, padding_bottom = 16,
@@ -119,21 +119,20 @@
             longerHelp = completedHelp
 
-        self._helpLabel = gtk.Label(longerHelp)
+        self._helpLabel = Gtk.Label(longerHelp)
         # FIXME: should be a constant in common
-        self._helpLabel.set_justify(gtk.Justification.CENTER if pygobject
-                                    else gtk.JUSTIFY_CENTER)
+        self._helpLabel.set_justify(Gtk.Justification.CENTER)
         self._helpLabel.set_use_markup(True)
         alignment.add(self._helpLabel)
         mainBox.pack_start(alignment, False, False, 0)
 
-        self._mainAlignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        self._mainAlignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                             xscale = 1.0, yscale = 1.0)
         mainBox.pack_start(self._mainAlignment, True, True, 0)
 
-        buttonAlignment =  gtk.Alignment(xalign = 1.0, xscale=0.0, yscale = 0.0)
+        buttonAlignment =  Gtk.Alignment(xalign = 1.0, xscale=0.0, yscale = 0.0)
         buttonAlignment.set_padding(padding_top = 4, padding_bottom = 10,
                                     padding_left = 16, padding_right = 16)
 
-        self._buttonBox = gtk.HBox()
+        self._buttonBox = Gtk.HBox()
         self._buttonBox.set_homogeneous(False)
         self._defaultButton = None
@@ -176,5 +175,5 @@
 
         Return the button object created."""
-        button = gtk.Button(label)
+        button = Gtk.Button(label)
         self._buttonBox.pack_start(button, False, False, padding)
         button.set_use_underline(True)
@@ -220,14 +219,9 @@
     def setStyle(self):
         """Set the styles of some of the items on the page."""
-        if pygobject:
-            context = self.get_style_context()
-            color = context.get_background_color(gtk.StateFlags.SELECTED)
-            self._titleEventBox.modify_bg(0, color.to_color())
-            color = context.get_color(gtk.StateFlags.SELECTED)
-            self._titleLabel.modify_fg(0, color.to_color())
-        else:
-            style = self.rc_get_style()
-            self._titleEventBox.modify_bg(0, style.bg[3])
-            self._titleLabel.modify_fg(0, style.fg[3])
+        context = self.get_style_context()
+        color = context.get_background_color(Gtk.StateFlags.SELECTED)
+        self._titleEventBox.modify_bg(0, color.to_color())
+        color = context.get_color(Gtk.StateFlags.SELECTED)
+        self._titleLabel.modify_fg(0, color.to_color())
 
     def initialize(self):
@@ -305,8 +299,8 @@
                                         xstr("login"), xstr("loginHelp"))
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(3, 2)
+        table = Gtk.Table(3, 2)
         table.set_row_spacings(4)
         table.set_col_spacings(32)
@@ -314,12 +308,12 @@
         self.setMainWidget(alignment)
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("label_pilotID"))
+        label = Gtk.Label(xstr("label_pilotID"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, 0, 1)
 
-        self._pilotID = gtk.Entry()
+        self._pilotID = Gtk.Entry()
         self._pilotID.connect("changed", self._pilotIDChanged)
         self._pilotID.set_tooltip_text(xstr("login_pilotID_tooltip"))
@@ -327,12 +321,12 @@
         label.set_mnemonic_widget(self._pilotID)
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("label_password"))
+        label = Gtk.Label(xstr("label_password"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, 1, 2)
 
-        self._password = gtk.Entry()
+        self._password = Gtk.Entry()
         self._password.set_visibility(False)
         self._password.connect("changed", self._setControls)
@@ -341,5 +335,5 @@
         label.set_mnemonic_widget(self._password)
 
-        self._rememberButton = gtk.CheckButton(xstr("remember_password"))
+        self._rememberButton = Gtk.CheckButton(xstr("remember_password"))
         self._rememberButton.set_use_underline(True)
         self._rememberButton.set_tooltip_text(xstr("login_remember_tooltip"))
@@ -405,10 +399,10 @@
     def _offlineClicked(self, button):
         """Called when the offline button was clicked."""
-        print "mlx.flight.LoginPage: offline flight selected"
+        print("mlx.flight.LoginPage: offline flight selected")
         self._wizard.nextPage()
 
     def _loginClicked(self, button):
         """Called when the login button was clicked."""
-        print "mlx.flight.LoginPage: logging in"
+        print("mlx.flight.LoginPage: logging in")
         self._wizard.login(self._handleLoginResult,
                            self._pilotID.get_text(),
@@ -446,10 +440,10 @@
                                                   help, completedHelp = completedHelp)
 
-        mainBox = gtk.HBox()
+        mainBox = Gtk.HBox()
         mainBox.set_homogeneous(False)
 
-        leftVBox = gtk.VBox()
-
-        alignment = gtk.Alignment(xscale = 1.0)
+        leftVBox = Gtk.VBox()
+
+        alignment = Gtk.Alignment(xscale = 1.0)
         alignment.set_size_request(100, 0)
 
@@ -466,11 +460,11 @@
         mainBox.pack_start(self._flightList, False, False, 8)
 
-        flightButtonBox = gtk.VBox()
-
-        alignment = gtk.Alignment(xscale = 1.0)
+        flightButtonBox = Gtk.VBox()
+
+        alignment = Gtk.Alignment(xscale = 1.0)
         alignment.set_size_request(100, 0)
         flightButtonBox.pack_start(alignment, False, False, 0)
 
-        flightButtonWidthAlignment = gtk.Alignment(xscale=1.0, yscale=0.0,
+        flightButtonWidthAlignment = Gtk.Alignment(xscale=1.0, yscale=0.0,
                                                    xalign=0.0, yalign=0.0)
         flightButtonWidthAlignment.set_padding(padding_top = 0,
@@ -478,7 +472,7 @@
                                                padding_left = 8,
                                                padding_right = 0)
-        flightButtonWidthBox = gtk.VBox()
-
-        self._saveButton = gtk.Button(xstr("flightsel_save"))
+        flightButtonWidthBox = Gtk.VBox()
+
+        self._saveButton = Gtk.Button(xstr("flightsel_save"))
         self._saveButton.set_use_underline(True)
         self._saveButton.set_sensitive(False)
@@ -488,5 +482,5 @@
         flightButtonWidthBox.pack_start(self._saveButton, True, True, 4)
 
-        self._printButton = gtk.Button(xstr("flightsel_print"))
+        self._printButton = Gtk.Button(xstr("flightsel_print"))
         self._printButton.set_use_underline(True)
         self._printButton.set_sensitive(False)
@@ -496,5 +490,5 @@
         flightButtonWidthBox.pack_start(self._printButton, True, True, 4)
 
-        self._deleteButton = gtk.Button(xstr("flightsel_delete"))
+        self._deleteButton = Gtk.Button(xstr("flightsel_delete"))
         self._deleteButton.set_use_underline(True)
         self._deleteButton.set_sensitive(False)
@@ -647,17 +641,17 @@
         dialog.hide()
 
-        if response==RESPONSETYPE_OK:
-            fileName = text2unicode(dialog.get_filename())
-            print "Saving", fileName
+        if response==Gtk.ResponseType.OK:
+            fileName = dialog.get_filename()
+            print("Saving", fileName)
             try:
                 with open(fileName, "wt") as f:
                     flight.writeIntoFile(f)
-            except Exception, e:
-                print "Failed to save flight:", util.utf2unicode(str(e))
-                dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
-                                           type = MESSAGETYPE_ERROR,
+            except Exception as e:
+                print("Failed to save flight:", util.utf2unicode(str(e)))
+                dialog = Gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
+                                           type = Gtk.MessageType.ERROR,
                                            message_format =
                                            xstr("flightsel_save_failed"))
-                dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+                dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
                 dialog.set_title(WINDOW_TITLE_BASE)
                 secondary = xstr("flightsel_save_failed_sec")
@@ -675,5 +669,5 @@
         flight = self._getSelectedFlight()
 
-        printOperation = gtk.PrintOperation()
+        printOperation = Gtk.PrintOperation()
         if self._printSettings is not None:
             printOperation.set_print_settings(self._printSettings)
@@ -690,10 +684,10 @@
         printOperation.set_use_full_page(False)
 
-        result = printOperation.run(gtk.PRINT_OPERATION_ACTION_PRINT_DIALOG,
+        result = printOperation.run(Gtk.PrintOperationAction.PRINT_DIALOG,
                                     wizard.gui.mainWindow)
 
-        if result == gtk.PRINT_OPERATION_RESULT_APPLY:
+        if result == Gtk.PrintOperationResult.APPLY:
             self._printSettings = printOperation.get_print_settings()
-        elif result == gtk.PRINT_OPERATION_RESULT_ERROR:
+        elif result == Gtk.PrintOperationResult.ERROR:
             errorDialog(xstr("flightsel_print_failed",
                              wizard.gui.mainWindow,
@@ -706,9 +700,10 @@
         flight=self._getSelectedFlight()
 
-        print "DPI", context.get_dpi_x(), context.get_dpi_y()
+        print("DPI", context.get_dpi_x(), context.get_dpi_y())
 
         scale = context.get_dpi_x() / 72.0
 
         cr = context.get_cairo_context()
+
         cr.set_antialias(cairo.ANTIALIAS_GRAY)
 
@@ -718,13 +713,15 @@
         cr.stroke()
 
-        layout = cr.create_layout()
-        layout.set_text(u"Malév VA official briefing")
-        font = pango.FontDescription("sans")
-        font.set_size(int(32 * scale * pango.SCALE))
-        font.set_weight(pango.WEIGHT_NORMAL)
+        pcr = context.create_pango_context()
+
+        layout = Pango.Layout(pcr)
+        layout.set_text("Malév VA official briefing")
+        font = Pango.FontDescription("sans")
+        font.set_size(int(32 * Pango.SCALE))
+        font.set_weight(Pango.Weight.NORMAL)
         layout.set_font_description(font)
 
-        (_ink, (x0, y0, x1, y1)) = layout.get_extents()
-        width = float(x1 + 1 - x0) / pango.SCALE
+        (_ink, logical) = layout.get_extents()
+        width = logical.width / Pango.SCALE
 
         y = 25 * scale
@@ -732,28 +729,28 @@
         cr.move_to((context.get_width() - width)/2.0, y)
         cr.set_line_width(0.1 * scale)
-        cr.layout_path(layout)
+        PangoCairo.layout_path(cr, layout)
         cr.stroke_preserve()
         cr.fill()
 
-        y += float(y1 + 1 - y0) / pango.SCALE
+        y += logical.height / Pango.SCALE
         y += 6 * scale
 
-        layout = cr.create_layout()
-        layout.set_text(u"%s (%s) részére" %
+        layout = Pango.Layout(pcr)
+        layout.set_text("%s (%s) részére" %
                         (loginResult.pilotName, loginResult.pilotID))
-        font = pango.FontDescription("sans")
-        font.set_size(int(16 * scale * pango.SCALE))
-        font.set_weight(450)
+        font = Pango.FontDescription("sans")
+        font.set_size(int(16 * Pango.SCALE))
+        font.set_weight(Pango.Weight.MEDIUM)
         layout.set_font_description(font)
-        (_ink, (x0, y0, x1, y1)) = layout.get_extents()
-        width = float(x1 + 1 - x0) / pango.SCALE
+        (_ink, logical) = layout.get_extents()
+        width = logical.width / Pango.SCALE
 
         cr.move_to((context.get_width() - width)/2.0, y)
         cr.set_line_width(0.1 * scale)
-        cr.layout_path(layout)
+        PangoCairo.layout_path(cr, layout)
         cr.stroke_preserve()
         cr.fill()
 
-        y += float(y1 + 1 - y0) / pango.SCALE
+        y += logical.height / Pango.SCALE
         y += 4 * scale
 
@@ -765,7 +762,7 @@
         y += 20 * scale
 
-        font = pango.FontDescription("sans")
-        font.set_size(int(7 * scale * pango.SCALE))
-        font.set_weight(150)
+        font = Pango.FontDescription("sans")
+        font.set_size(int(7 * Pango.SCALE))
+        font.set_weight(Pango.Weight.ULTRALIGHT)
 
         table = []
@@ -799,13 +796,13 @@
         totalHeight = 0
         for (label, value) in table:
-            labelLayout = cr.create_layout()
+            labelLayout = Pango.Layout(pcr)
             labelLayout.set_text(label)
             labelLayout.set_font_description(font)
 
-            (_ink, (x0, y0, x1, y1)) = labelLayout.get_extents()
-            maxLabelWidth = max(maxLabelWidth, x1 + 1 - x0)
-            labelHeight = y1 + 1 - y0
-
-            valueLayout = cr.create_layout()
+            (_ink, logical) = labelLayout.get_extents()
+            maxLabelWidth = max(maxLabelWidth, logical.width)
+            labelHeight = logical.height
+
+            valueLayout = Pango.Layout(pcr)
             valueLayout.set_text(value)
             valueLayout.set_font_description(font)
@@ -813,5 +810,5 @@
             labelLayouts.append((labelLayout, valueLayout, labelHeight))
 
-        maxLabelWidth = maxLabelWidth / pango.SCALE
+        maxLabelWidth = maxLabelWidth / Pango.SCALE
 
         valueX = labelX + labelValueFill + maxLabelWidth
@@ -821,10 +818,10 @@
             (labelFill + maxLabelWidth + labelValueFill + valueFill)
         for (labelLayout, valueLayout, labelHeight) in labelLayouts:
-            valueLayout.set_width(int(valueWidth * pango.SCALE))
-
-            (_ink, (x0, y0, x1, y1)) = valueLayout.get_extents()
-            valueHeight = y1 + 1 - y0
-
-            height = float(max(labelHeight, valueHeight))/pango.SCALE
+            valueLayout.set_width(int(valueWidth * Pango.SCALE))
+
+            (_ink, logical) = valueLayout.get_extents()
+            valueHeight = logical.height
+
+            height = float(max(labelHeight, valueHeight))/Pango.SCALE
             layouts.append((labelLayout, valueLayout, height))
 
@@ -843,5 +840,5 @@
             cr.move_to(labelX, y)
             cr.set_line_width(0.1)
-            cr.layout_path(labelLayout)
+            PangoCairo.layout_path(cr, labelLayout)
             cr.stroke_preserve()
             cr.fill()
@@ -849,5 +846,5 @@
             cr.move_to(valueX, y)
             cr.set_line_width(0.1)
-            cr.layout_path(valueLayout)
+            PangoCairo.layout_path(cr, valueLayout)
             cr.stroke_preserve()
             cr.fill()
@@ -884,5 +881,5 @@
     def _deleteResultCallback(self, returned, result):
         """Called when the deletion result is available."""
-        gobject.idle_add(self._handleDeleteResult, returned, result)
+        GObject.idle_add(self._handleDeleteResult, returned, result)
 
     def _handleDeleteResult(self, returned, result):
@@ -938,7 +935,7 @@
         dialog.hide()
 
-        if response==RESPONSETYPE_OK:
-            fileName = text2unicode(dialog.get_filename())
-            print "Loading", fileName
+        if response==Gtk.ResponseType.OK:
+            fileName = dialog.get_filename()
+            print("Loading", fileName)
             bookedFlight = web.BookedFlight()
             try:
@@ -946,11 +943,11 @@
                     bookedFlight.readFromFile(f)
                 self.addFlight(bookedFlight)
-            except Exception, e:
-                print "Failed to load flight:", util.utf2unicode(str(e))
-                dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
-                                           type = MESSAGETYPE_ERROR,
+            except Exception as e:
+                print("Failed to load flight:", util.utf2unicode(str(e)))
+                dialog = Gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
+                                           type = Gtk.MessageType.ERROR,
                                            message_format =
                                            xstr("flightsel_load_failed"))
-                dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+                dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
                 dialog.set_title(WINDOW_TITLE_BASE)
                 secondary = xstr("flightsel_load_failed_sec")
@@ -1030,20 +1027,20 @@
 
         gui = self._wizard.gui
-        dialog = gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
+        dialog = Gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
                                        xstr("flightsel_save_title"),
-                                       action = FILE_CHOOSER_ACTION_SAVE,
-                                       buttons = (gtk.STOCK_CANCEL,
-                                                  RESPONSETYPE_CANCEL,
-                                                  gtk.STOCK_OK, RESPONSETYPE_OK),
+                                       action = Gtk.FileChooserAction.SAVE,
+                                       buttons = (Gtk.STOCK_CANCEL,
+                                                  Gtk.ResponseType.CANCEL,
+                                                  Gtk.STOCK_OK, Gtk.ResponseType.OK),
                                        parent = gui.mainWindow)
         dialog.set_modal(True)
         dialog.set_do_overwrite_confirmation(True)
 
-        filter = gtk.FileFilter()
+        filter = Gtk.FileFilter()
         filter.set_name(xstr("flightsel_filter_flights"))
         filter.add_pattern("*.vaflight")
         dialog.add_filter(filter)
 
-        filter = gtk.FileFilter()
+        filter = Gtk.FileFilter()
         filter.set_name(xstr("file_filter_all"))
         filter.add_pattern("*.*")
@@ -1060,19 +1057,19 @@
 
         gui = self._wizard.gui
-        dialog = gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
+        dialog = Gtk.FileChooserDialog(title = WINDOW_TITLE_BASE + " - " +
                                        xstr("flightsel_load_title"),
-                                       action = FILE_CHOOSER_ACTION_OPEN,
-                                       buttons = (gtk.STOCK_CANCEL,
-                                                  RESPONSETYPE_CANCEL,
-                                                  gtk.STOCK_OK, RESPONSETYPE_OK),
+                                       action = Gtk.FileChooserAction.OPEN,
+                                       buttons = (Gtk.STOCK_CANCEL,
+                                                  Gtk.ResponseType.CANCEL,
+                                                  Gtk.STOCK_OK, Gtk.ResponseType.OK),
                                        parent = gui.mainWindow)
         dialog.set_modal(True)
 
-        filter = gtk.FileFilter()
+        filter = Gtk.FileFilter()
         filter.set_name(xstr("flightsel_filter_flights"))
         filter.add_pattern("*.vaflight")
         dialog.add_filter(filter)
 
-        filter = gtk.FileFilter()
+        filter = Gtk.FileFilter()
         filter.set_name(xstr("file_filter_all"))
         filter.add_pattern("*.*")
@@ -1085,7 +1082,7 @@
     def _createListPopupMenu(self):
         """Get the flight list popup menu."""
-        menu = gtk.Menu()
-
-        menuItem = gtk.MenuItem()
+        menu = Gtk.Menu()
+
+        menuItem = Gtk.MenuItem()
         menuItem.set_label(xstr("flightsel_popup_select"))
         menuItem.set_use_underline(True)
@@ -1095,5 +1092,5 @@
         menu.append(menuItem)
 
-        menuItem = gtk.MenuItem()
+        menuItem = Gtk.MenuItem()
         menuItem.set_label(xstr("flightsel_popup_save"))
         menuItem.set_use_underline(True)
@@ -1103,5 +1100,5 @@
         menu.append(menuItem)
 
-        menuItem = gtk.MenuItem()
+        menuItem = Gtk.MenuItem()
         menuItem.set_label(xstr("flightsel_popup_print"))
         menuItem.set_use_underline(True)
@@ -1111,5 +1108,5 @@
         menu.append(menuItem)
 
-        menuItem = gtk.MenuItem()
+        menuItem = Gtk.MenuItem()
         menuItem.set_label(xstr("flightsel_popup_delete"))
         menuItem.set_use_underline(True)
@@ -1152,7 +1149,7 @@
                                                 xstr("gatesel_help"))
 
-        self._listStore = gtk.ListStore(str)
-        self._gateList = gtk.TreeView(self._listStore)
-        column = gtk.TreeViewColumn(None, gtk.CellRendererText(),
+        self._listStore = Gtk.ListStore(str)
+        self._gateList = Gtk.TreeView(self._listStore)
+        column = Gtk.TreeViewColumn(None, Gtk.CellRendererText(),
                                     text = 0)
         column.set_expand(True)
@@ -1164,15 +1161,12 @@
         gateSelection.connect("changed", self._selectionChanged)
 
-        scrolledWindow = gtk.ScrolledWindow()
+        scrolledWindow = Gtk.ScrolledWindow()
         scrolledWindow.add(self._gateList)
         scrolledWindow.set_size_request(50, -1)
-        scrolledWindow.set_policy(gtk.PolicyType.AUTOMATIC if pygobject
-                                  else gtk.POLICY_AUTOMATIC,
-                                  gtk.PolicyType.AUTOMATIC if pygobject
-                                  else gtk.POLICY_AUTOMATIC)
-        scrolledWindow.set_shadow_type(gtk.ShadowType.IN if pygobject
-                                       else gtk.SHADOW_IN)
-
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.0, xscale = 0.0, yscale = 1.0)
+        scrolledWindow.set_policy(Gtk.PolicyType.AUTOMATIC,
+                                  Gtk.PolicyType.AUTOMATIC)
+        scrolledWindow.set_shadow_type(Gtk.ShadowType.IN)
+
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.0, xscale = 0.0, yscale = 1.0)
         alignment.add(scrolledWindow)
 
@@ -1236,8 +1230,8 @@
             self._wizard.jumpPage("connect")
         else:
-            dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
-                                       type = MESSAGETYPE_ERROR,
+            dialog = Gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
+                                       type = Gtk.MessageType.ERROR,
                                        message_format = xstr("gatesel_conflict"))
-            dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+            dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
             dialog.set_title(WINDOW_TITLE_BASE)
             dialog.format_secondary_markup(xstr("gatesel_conflict_sec"))
@@ -1274,10 +1268,10 @@
                                            xstr("register_help"))
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(12, 3)
+        table = Gtk.Table(12, 4)
         table.set_row_spacings(4)
-        table.set_col_spacings(32)
+        table.set_col_spacings(24)
         alignment.add(table)
         self.setMainWidget(alignment)
@@ -1285,12 +1279,12 @@
         row = 0
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_name1"))
+        label = Gtk.Label(xstr("register_name1"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        self._name1 = gtk.Entry()
+        self._name1 = Gtk.Entry()
         self._name1.connect("changed", self._updateButtons)
         self._name1.set_tooltip_text(xstr("register_name1_tooltip"))
@@ -1299,33 +1293,31 @@
         label.set_mnemonic_widget(self._name1)
 
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
+                                       xscale = 0.0, yscale = 0.0)
+        label = Gtk.Label(xstr("register_name2"))
+        label.set_use_underline(True)
+        labelAlignment.add(label)
+        table.attach(labelAlignment, 2, 3, row, row+1)
+
+        self._name2 = Gtk.Entry()
+        self._name2.connect("changed", self._updateButtons)
+        self._name2.set_tooltip_text(xstr("register_name2_tooltip"))
+        self._name2.set_width_chars(15)
+        table.attach(self._name2, 3, 4, row, row+1)
+        label.set_mnemonic_widget(self._name2)
+
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_name2"))
+        label = Gtk.Label(xstr("register_year_of_birth"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        self._name2 = gtk.Entry()
-        self._name2.connect("changed", self._updateButtons)
-        self._name2.set_tooltip_text(xstr("register_name2_tooltip"))
-        self._name2.set_width_chars(15)
-        table.attach(self._name2, 1, 2, row, row+1)
-        label.set_mnemonic_widget(self._name2)
-
-        row += 1
-
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
-                                       xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_year_of_birth"))
-        label.set_use_underline(True)
-        labelAlignment.add(label)
-        table.attach(labelAlignment, 0, 1, row, row+1)
-
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 0.0, yscale = 0.0)
 
-        self._yearOfBirth = gtk.SpinButton()
+        self._yearOfBirth = Gtk.SpinButton()
         self._yearOfBirth.set_increments(step = 1, page = 10)
         self._yearOfBirth.set_range(min = RegisterPage._minYearOfBirth,
@@ -1342,12 +1334,12 @@
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_email"))
+        label = Gtk.Label(xstr("register_email"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        self._emailAddress = gtk.Entry()
+        self._emailAddress = Gtk.Entry()
         self._emailAddress.connect("changed", self._updateButtons)
         self._emailAddress.set_tooltip_text(xstr("register_email_tooltip"))
@@ -1355,19 +1347,19 @@
         label.set_mnemonic_widget(self._emailAddress)
 
-        self._emailAddressPublic = gtk.CheckButton(xstr("register_email_public"))
+        self._emailAddressPublic = Gtk.CheckButton(xstr("register_email_public"))
         self._emailAddressPublic.set_use_underline(True)
         self._emailAddressPublic.set_tooltip_text(xstr("register_email_public_tooltip"))
-        table.attach(self._emailAddressPublic, 2, 3, row, row+1)
+        table.attach(self._emailAddressPublic, 2, 4, row, row+1)
 
         row += 1
 
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 1.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_vatsim_id"))
+        label = Gtk.Label(xstr("register_vatsim_id"))
         label.set_use_underline(True)
         labelAlignment.add(label)
         table.attach(labelAlignment, 0, 1, row, row+1)
 
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 0.0, yscale = 0.0)
         self._vatsimID = IntegerEntry()
@@ -1379,14 +1371,12 @@
         label.set_mnemonic_widget(self._vatsimID)
 
-        row += 1
-
-        labelAlignment = gtk.Alignment(xalign = 1.0, yalign = 0.5,
+        labelAlignment = Gtk.Alignment(xalign = 0.0, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("register_ivao_id"))
+        label = Gtk.Label(xstr("register_ivao_id"))
         label.set_use_underline(True)
         labelAlignment.add(label)
-        table.attach(labelAlignment, 0, 1, row, row+1)
-
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        table.attach(labelAlignment, 2, 3, row, row+1)
+
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                   xscale = 0.0, yscale = 0.0)
         self._ivaoID = IntegerEntry()
